--  _          _ _         _   _                     
-- | |__   ___| | | ___   | |_| |__   ___ _ __ ___   
-- | '_ \ / _ \ | |/ _ \  | __| '_ \ / _ \ '__/ _ \  
-- | | | |  __/ | | (_) | | |_| | | |  __/ | |  __/_ 
-- |_| |_|\___|_|_|\___/   \__|_| |_|\___|_|  \___(_)
--
-- This was Reusable, then it wasn't, then it was again.
-- Go nuts and do what you want, I've been away from v1 dev for way too long to be stingy.
--
-- HORNMOD was my first major project for Kart, and it's kicked off a wild period of my life, as corny as that sounds.
-- I've met a lot of new friends, I've learned a lot about disciplines that I love, and I get to appreciate cute robots.
-- It's been neat to come back to it and realize how much I've learned, and I hope the refinements are worth it.
--
-- Here's to Kart, which I'm convinced is unkillable at this point.
-- Happy honking. 
-- - Tyron, 2020-09-12
rawset(_G, "HORNMOD", "2")
-- print("\142HORNMOD *Championship Edition* v"..HORNMOD.." - a Tyron thing") Only removed because this is modified and may confuse users. I think everyone knows by now Hornmod is by Tyron
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local ANG12 = ANG10 + ANG2
local MF2_SHADOW = MF2_SHADOW
local MFE_VERTICALFLIP = MFE_VERTICALFLIP
local BT_VOTE = (1<<7) -- why is this not exposed

local horn_debug = CV_RegisterVar({
	name = "horn_debug",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local horn_hellchance = CV_RegisterVar({
	name = "horn_hellchance",
	defaultvalue = "5",
	flags = CV_NETVAR,
	possiblevalue = { MIN = 0, MAX = 1000 }
})
local horn_preferexpansions = CV_RegisterVar({
	name = "horn_preferexpansions",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local horn_antispam = CV_RegisterVar({
	name = "horn_explode",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function(cv)
		if cv.value == 1 then return end
		for p in players.iterate do
			if p.hornmod then
				p.hornmod.warnstate = 0
				p.hornmod.horncount = 0
			end
		end
	end
})
local horn_unleashhell = CV_RegisterVar({
	name = "horn_unleashhell",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function()
		for p in players.iterate
			if p.hornmod and p.hornmod.selection then
				p.hornmod.selection = 0
				CONS_Printf(p, "Your horn was reset because the host changed settings.")
			end
			if p.hornmod and p.hornmod.faves then
				p.hornmod.faves = nil
				CONS_Printf(p, "Your faves were reset because the host changed settings.")
			end
		end
	end
})
local horn_truerandom = CV_RegisterVar({
	name = "horn_truerandom",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff,
})

-- Ignore countdown removed because you can practically horn at the position sections - haya

local horn_forcehorn = CV_RegisterVar({
	name = "horn_forcehorn",
	defaultvalue = 0,
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned,
})

local horn_volume = CV_RegisterVar({
	name = "horn_volume",
	defaultvalue = "1.0",
	possiblevalue = {
		MIN = 0,
		MAX = FRACUNIT,
	},
	flags = CV_FLOAT,
})

local horn_shutupbehavior = CV_RegisterVar({
	name = "horn_shutupbehavior",
	defaultvalue = "Muffle",
	possiblevalue = {
		Muffle = 0,
		Mute = 1,
	},
})

local function hornVolume()
	return FixedMul(horn_volume.value, 255<<FRACBITS)>>FRACBITS
end

local horns = {}
local hellhorns = {}
local baseexpanded = false
local hellexpanded = false
rawset(_G, "HORNMOD_Horns", function()
	return horns
end)
rawset(_G, "HORNMOD_HellHorns", function()
	return hellhorns
end)

local function dprint(...)
	if not horn_debug.value then return end
	local fug = "\132[HORNMOD CE]\128 "
	if leveltime then fug = $ + "\132(" + leveltime + ")\128 " end
	if not ... then
		fug = $ + "Did you seriously pass NOTHING to a debug print?"
	else
		fug = $ + table.concat({...}, " ")
	end
	CONS_Printf(consoleplayer, fug)
end

freeslot("sfx_hmwarn")
freeslot("sfx_hmdang")
freeslot("sfx_hmslct")
freeslot("sfx_hmhell")
-- freeslot("sfx_hmstop") -- unused FOR NOW...

freeslot("sfx_hmbebo")
freeslot("SPR_EXLP")
freeslot("S_HORNEXPLOSION")

states[S_HORNEXPLOSION] = {
        sprite = SPR_EXLP,
        frame = FF_FULLBRIGHT|FF_ANIMATE|A,
        tics = 15,
        var1 = 8,
        var2 = 2,
        nextstate = S_NULL
}

-- Ring Racers has it's own horn object for followers. To save freeslots, let's just use that instead.
addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid and (mo.target.player or mo.target.type == MT_FOLLOWER)) then
		P_RemoveMobj(mo)
	end
end, MT_HORNCODE)

addHook("MobjThinker", function(mo)
	-- follower horn, ignore everything
	if not (mo and mo.valid and mo.target and mo.target.valid and mo.target.player and mo.target.player.valid) then
		return
	end
	
	local pmo = mo.target
	local hm = pmo.player.hornmod

	local hofs = pmo.height - mapobjectscale*8
	if pmo.eflags & MFE_VERTICALFLIP then
		hofs = mapobjectscale*8
	end

	mo.eflags = ($ & ~MFE_VERTICALFLIP) | (pmo.eflags & MFE_VERTICALFLIP)
	mo.color = pmo.color
	mo.spriteyoffset = pmo.spriteyoffset
	mo.scale = FixedMul(pmo.scale, FRACUNIT + min(hm.shake/256, FRACUNIT)) -- encourage spamming
	if hm.flash then
		mo.color = SKINCOLOR_YELLOW
		mo.scale = FixedMul($, 11*FRACUNIT/10)
	end
	
	local shake = min(hm.shake/2, 15*FRACUNIT)

	-- PRNG since visual won't update if a client can't see it, meaning real randomness desyncs
	P_MoveOrigin(mo,
		pmo.x + FixedMul(N_Random()/FRACUNIT, shake),
		pmo.y + FixedMul(N_Random()/FRACUNIT, shake),
		pmo.z + hofs + FixedMul(N_Random()/FRACUNIT, shake) + sin(leveltime * ANG12) - FRACUNIT/2)
	return true
end, MT_HORNCODE)

local function playercount()
	local pnum = 0
	for p in players.iterate
		if (not p.mo) or p.spectator then continue end -- dont count specators
		pnum = $+1
	end
	return pnum
end
-- Okay, this is a little bit of a hack, but I came up with the schema while delirious from illness so I know it's a good idea.
-- Basically, filtering tables sucks, updating tables sucks, all that.
-- But because we have a limited number of places that actually need to set the horn, just faking the table size is somewhat sustainable.
-- If a horn index is past the maximum number of normal horns, it's a hell horn: for instance, with 200 base horns, horn #202 is hellhorn #2.
-- Here are a few wrappers that make this hack less stupid.
-- (I swear, it's actually less complicated and more performant than doing this "correctly"!)
local function hellcount()
	if horn_unleashhell.value then return #horns + #hellhorns end
	return #horns
end
local function hellref(x)
	if x > #horns then return hellhorns[x - #horns] end
	return horns[x]
end
local function prettyhornname(h)
	if h > #horns then
		return "\134#" .. h .. ": \133" .. hellref(h).info
	else
		return "\135#" .. h .. ": \130" .. hellref(h).info
	end
end

local globalmute = false

COM_AddCommand("hornsoff", function(p)
	-- you probably shouldn't be using this at the title screen
	if not p.hornmod then print("?") return end

	if replayplayback then
		globalmute = not globalmute
	else
		for px in players.iterate do
			if px == p or px.hornmod.splitscreenmaster == p then
				if px == consoleplayer then
					globalmute = not px.hornmod.muted
					dprint("Globalmute set to", tostring(globalmute))
				end
				px.hornmod.muted = not px.hornmod.muted
				-- Funni mupack empty karts playing horn
				px.nethornenabled = not px.hornmod.muted
				dprint(px.hornmod.muted and "Muted" or "Unmuted", px.name)
			end
		end
	end

	if globalmute then
		CONS_Printf(p, "\131OK! \128You won't hear or send horns anymore. Try \130hornsoff\128 again if you change your mind.")
	else
		CONS_Printf(p, "\131OK! \128You will hear and send horns again. Welcome back!")
	end
end)

-- don't sync shutups to joiners
local muffled = {}

COM_AddCommand("shutup", function(p, target) -- Significantly reduce horn annoyance from a target player.
	if not target then
		CONS_Printf(p, "Specify a player who's bothering you, like \130shutup Tyron\128.")
		return
	end
	local loudidiot

	local pnum = tonumber(target)
	if pnum ~= nil and pnum < #players and pnum >= 0 then
		loudidiot = players[pnum] -- thanks, terminal!
	else
		pnum = -1
		target = $:lower()
		for p in players.iterate
			if p.name:lower():match(target) then
				if loudidiot then
					CONS_Printf(p, "That matches more than one player. Be more specific!")
					return
				end
				loudidiot = p
			end
		end
	end

	if loudidiot == nil then
		if pnum > 0 then CONS_Printf(p, "No player with that node number exists.")
		else CONS_Printf(p, "No player matching that name exists, check your spelling?") end
		return
	end

	if not muffled[#loudidiot] then -- yeah the condition is backwards, what about it
		muffled[#loudidiot] = true
		CONS_Printf(p, "\131OK! \128Horns from "..loudidiot.name.." will be way, way quieter.")
		CONS_Printf(p, "To undo this, just use the same command again.")
	else
		muffled[#loudidiot] = false
		CONS_Printf(p, "\131OK! \128You will hear horns from "..loudidiot.name.." again.")
	end
end, COM_LOCAL)

local function hornlist(p, i)
	local guard = tonumber(i) or 1
	local rangehelp = ""
	local pagesize = 20
	local adjust = 0
	local total = hellcount()
	if total % pagesize then
		adjust = 1
	end
	if guard < 0 or guard > (total / pagesize + adjust) then
		guard = 1
		rangehelp = " \134(ignored your page number, out of range)"
	end
	local pagedivider = "\134=== Page \130" .. guard .. " \134of \130" .. (total/pagesize + adjust) .. " \134===" .. rangehelp
	guard = $ - 1
	local lowbound = guard * pagesize + 1
	local highbound = min(total, guard * pagesize + pagesize)
	CONS_Printf(p, pagedivider)
	for h = lowbound, highbound do
		CONS_Printf(p, prettyhornname(h))
	end
	CONS_Printf(p, pagedivider)
	CONS_Printf(p, "Try something like \135listhorns 3\128, \135sethorn 42\128 or \135sethorn galaga\128.")
end
COM_AddCommand("listhorns", hornlist)

local function sethorn(p, ...)
	-- you probably shouldn't be using this at the title screen
	if not p.hornmod then print("?") return end

	local hm = p.hornmod
	local packedargs = {...}
	if #packedargs == 0 then
		CONS_Printf(p, "* \131(Trying \130listhorns\131...)")
		hornlist(p, 1)
		return
	end
	local guard = nil
	if #packedargs == 1 then
		guard = tonumber(packedargs[1])
	end
	if guard == nil or #packedargs > 1 then -- no direct number match, let's try a fuzzy search
		local searchstring = table.concat(packedargs, " "):lower()
		local hits = {}
		for k, v in ipairs(horns)
			if string.find(v.info:lower(), searchstring, 0, true) or (v.extags and string.find(v.extags:lower(), searchstring, 0, true)) then
				table.insert(hits, k)
			end
		end
		if horn_unleashhell.value then
			for k, v in ipairs(hellhorns) -- :GOD:
				if string.find(v.info:lower(), searchstring, 0, true) or (v.extags and string.find(v.extags:lower(), searchstring, 0, true)) then
					table.insert(hits, k + #horns)
				end
			end
		end
		if #hits > 1 then
			for k, v in ipairs(hits) do
				CONS_Printf(p, prettyhornname(v))
			end
			CONS_Printf(p, "\133Multiple horns match \135" .. searchstring .. "\133. \128Could you be more specific?")
			return
		elseif #hits == 0 then
			CONS_Printf(p, "\133No horns match \135" .. searchstring .. "\133. \128Check your spelling?")
			return
		else
			guard = hits[1]
		end
	end
	if guard == 0 then
		hm.selection = 0
		S_StartSound(nil, sfx_hmslct, p)
		CONS_Printf(p, "\131OK! \128Cleared your horn preference. Your next horn will be random.")
		return
	elseif guard < 1 or guard > hellcount() then
		CONS_Printf(p, "\133Out of range. \128Try a number between 1 and " .. hellcount() .. ", or use \135listhorns\128.")
		return
	end
	hm.selection = guard
	
	if (leveltime < 7*TICRATE or p.spectator) and not (horn_forcehorn.value or horn_truerandom.value) then
		hm.horn = guard
	end
	
	S_StartSound(nil, _G[hellref(guard).name], p)
	S_StartSound(nil, sfx_hmslct, p)
	CONS_Printf(p, "\131OK! \128Your horn will be " .. prettyhornname(guard) .. "\128 for the next race.\nUse \135resethorn\128 to return to random horns.")
end
COM_AddCommand("sethorn", sethorn)

COM_AddCommand("forcehorn", function(p, ...)
	local packedargs = {...}
	if #packedargs == 0 then
		CONS_Printf(p, "* \131(Trying \130listhorns\131...)")
		hornlist(p, 1)
		return
	end
	local guard = nil
	if #packedargs == 1 then
		guard = tonumber(packedargs[1])
	end
	if guard == nil or #packedargs > 1 then -- no direct number match, let's try a fuzzy search
		local searchstring = table.concat(packedargs, " "):lower()
		local hits = {}
		for k, v in ipairs(horns)
			if string.find(v.info:lower(), searchstring, 0, true) or (v.extags and string.find(v.extags:lower(), searchstring, 0, true)) then
				table.insert(hits, k)
			end
		end
		for k, v in ipairs(hellhorns) -- :GOD:
			if string.find(v.info:lower(), searchstring, 0, true) or (v.extags and string.find(v.extags:lower(), searchstring, 0, true)) then
				table.insert(hits, k + #horns)
			end
		end
		if #hits > 1 then
			for k, v in ipairs(hits) do
				CONS_Printf(p, prettyhornname(v))
			end
			CONS_Printf(p, "\133Multiple horns match \135" .. searchstring .. "\133. \128Could you be more specific?")
			return
		elseif #hits == 0 then
			CONS_Printf(p, "\133No horns match \135" .. searchstring .. "\133. \128Check your spelling?")
			return
		else
			guard = hits[1]
		end
	end
	if guard == 0 then
		COM_BufInsertText(p, "horn_forcehorn 0")
		S_StartSound(nil, sfx_hmslct, p)
		CONS_Printf(p, "\131OK! \128Force horn disabled")
		return
	elseif guard < 1 or guard > #horns + #hellhorns then
		CONS_Printf(p, "\133Out of range. \128Try a number between 1 and " .. (#horns + #hellhorns) .. ", or use \135listhorns\128.")
		return
	end
	COM_BufInsertText(p, "horn_forcehorn "..guard)
	S_StartSound(nil, _G[hellref(guard).name], p)
	S_StartSound(nil, sfx_hmslct, p)
	CONS_Printf(p, "\131OK! \128Force horn " .. prettyhornname(guard) .. "\128\nUse \135forcehorn 0\128 to to disable force horns")
end, COM_ADMIN)

-- helper provided for backcompat
COM_AddCommand("resethorn", function(p)
	sethorn(p, 0)
end)

COM_AddCommand("shutuphorn", function(p, ...)
	-- you probably shouldn't be using this at the title screen
	if not p.hornmod then print("?") return end

	local hm = p.hornmod
	local packedargs = {...}
	if #packedargs == 0 then
		CONS_Printf(p, "Usage: shutuphorn <number or name>")
		return
	end
	local guard = nil
	if #packedargs == 1 then
		guard = tonumber(packedargs[1])
	end
	if guard == nil or #packedargs > 1 then -- no direct number match, let's try a fuzzy search
		local searchstring = table.concat(packedargs, " "):lower()
		local hits = {}
		for k, v in ipairs(horns)
			if string.find(v.info:lower(), searchstring, 0, true) or (v.extags and string.find(v.extags:lower(), searchstring, 0, true)) then
				table.insert(hits, k)
			end
		end
		for k, v in ipairs(hellhorns) -- :GOD:
			if string.find(v.info:lower(), searchstring, 0, true) or (v.extags and string.find(v.extags:lower(), searchstring, 0, true)) then
				table.insert(hits, k + #horns)
			end
		end
		if #hits > 1 then
			for k, v in ipairs(hits) do
				CONS_Printf(p, prettyhornname(v))
			end
			CONS_Printf(p, "\133Multiple horns match \135" .. searchstring .. "\133. \128Could you be more specific?")
			return
		elseif #hits == 0 then
			CONS_Printf(p, "\133No horns match \135" .. searchstring .. "\133. \128Check your spelling?")
			return
		else
			guard = hits[1]
		end
	end
	if guard == 0 then
		CONS_Printf(p, "Are you trying to shut all horns? Try \133hornsoff\128 or set \133horn_volume\128 to be lower")
	elseif guard < 1 or guard > hellcount() then
		CONS_Printf(p, "\133Out of range. \128Try a number between 1 and " .. hellcount() .. ", or use \135listhorns\128.")
		return
	end
	
	hellref(guard).muffled = not $
	
	if hellref(guard).muffled then
		CONS_Printf(p, "\131OK! \128Horn " .. prettyhornname(guard) .. "\128 will be way more quiet. Use same command to undo this.")
	else
		CONS_Printf(p, "\131OK! \128Horn " .. prettyhornname(guard) .. "\128 will have normal volume again.")
	end
end, COM_LOCAL)

-- expert mode / horn testing
COM_AddCommand("adjusthorn", function(p, target)
	-- you probably shouldn't be using this at the title screen
	if not p.hornmod then print("?") return end

	local hm = p.hornmod
	if target == "random" then
		hm.selection = P_RandomRange(1, hellcount())
	else
		local guard = tonumber(target)
		if not guard or guard > #horns then
			CONS_Printf(p, "Why")
			return
		end
		if (not hm.selection) or hm.selection < 1 then
			hm.selection = 1
		else
			hm.selection = (($ + target + hellcount()) % hellcount()) or hellcount()
		end
	end
	
	if (leveltime < 7*TICRATE or p.spectator) and not (horn_forcehorn.value or horn_truerandom.value) then
		hm.horn = hm.selection
	end
	
	S_StartSound(nil, _G[hellref(hm.selection).name], p)
	CONS_Printf(p, prettyhornname(hm.selection))
end)

local function strsplit(s, delimiter)
	local result = {}
	for match in (s..delimiter):gmatch("(.-)"..delimiter) do
		table.insert(result, match)
	end
	return result
end

-- helper provided for backcompat
COM_AddCommand("favehorn", function(p, ...)
	-- you probably shouldn't be using this at the title screen
	if not p.hornmod then print("?") return end

	local packedargs = {...}
	if #packedargs < 1 then
		CONS_Printf(p, "Specify multiple horn #s. While you don't have another horn set, you'll swap between them.\nExample: \130favehorn 11 28 35-39 53")
		CONS_Printf(p, "Use \130favehorn reset\128 to clear your favored horns and enable all loaded horns.")
		return
	end
	if #packedargs == 1 and (packedargs[1] == "0" or packedargs[1] == "reset") then
		CONS_Printf(p, "Cleared your favorite horns.")
		p.hornmod.faves = nil
		return
	end
	local tfaves = {}
	for i = 1, #packedargs
		local arg = packedargs[i]
		local guard = tonumber(arg)
		if guard then -- number
			if guard > hellcount() or guard < 1 then
				CONS_Printf(p, "Got confused when reading this segment (out of range): \130"..arg)
				return
			end
			table.insert(tfaves, guard)
		else -- try argparse
			local args = strsplit(arg, "-")
			if #args == 2 then
				local lbound = tonumber(args[1])
				local ubound = tonumber(args[2])
				if not (lbound and ubound) then
					CONS_Printf(p, "Got confused when reading this segment (not numbers): \130"..arg)
					return
				end
				if lbound < 1 or ubound > hellcount() or lbound > ubound then
					CONS_Printf(p, "Got confused when reading this segment (pair out of range): \130"..arg)
					return
				end
				for j = lbound, ubound
					table.insert(tfaves, j)
				end
			else
				CONS_Printf(p, "Got confused when reading this segment (wrong args): \130"..arg)
				return
			end
		end
	end
	p.hornmod.faves = tfaves
	CONS_Printf(p, "\131OK! \128Set your favored horns. These will be used when you don't have something else selected.")
end)

-- helper provided for backcompat
local function horn(p, ...)
	if ... then
		CONS_Printf(p, "* \131(Trying \130sethorn "..table.concat({...}, " ").."\131...)")
		sethorn(p, ...)
		return
	end

	-- you probably shouldn't be using this at the title screen
	if not p.hornmod then print("?") return end

	local hm = p.hornmod
	-- ugly begins here
	if hm.horn then
		CONS_Printf(p, "Current horn:  "..prettyhornname(hm.horn))
	else
		CONS_Printf(p, "Current horn:  \130None!")
	end
	if hm.selection then
		CONS_Printf(p, "Selected horn: "..prettyhornname(hm.selection))
	else
		CONS_Printf(p, "Selected horn: \130None!")
	end
	if hm.faves then
		local fug = hm.faves
		CONS_Printf(p, "Favored horns: \130"..#fug.." selected")
	else
		CONS_Printf(p, "Favored horns: \130None!")
	end
	CONS_Printf(p, " ")
	CONS_Printf(p, "Commands: \130listhorns\128, \130sethorn\128, \130keephorn\128, \130resethorn\128, \130favehorn\128, \130hornsoff\128, \130shutup")
end
COM_AddCommand("horn", horn)

COM_AddCommand("keephorn", function(p)
	-- you probably shouldn't be using this at the title screen
	if not p.hornmod then print("?") return end

	local hm = p.hornmod
	if hm.horn then
		if hm.horn > hellcount() then
			CONS_Printf(p, "You can't keep a hellhorn. SUPER NICE TRY")
		else
			S_StartSound(nil, _G[hellref(hm.horn).name], p)
			S_StartSound(nil, sfx_hmslct, p)
			CONS_Printf(p, "\131OK!\128 You'll use "..prettyhornname(hm.horn).."\128 from now on.")
			hm.selection = hm.horn
		end
	else
		CONS_Printf(p, "You don't have a horn to keep yet!")
	end
end)

local function allocatenewhorn(name)
	if not _G[name] then
		freeslot(name)
		sfxinfo[_G[name]].flags = SF_X4AWAYSOUND
	else
		print(name .. " already allocated, distance flag will be wrong!")
	end
end

local function selectHorn(hm)
	if hm.faves and (not hm.selection) then
		hm.horn = hm.faves[P_RandomRange(1, #hm.faves)]
	else
		repeat
			hm.horn = P_RandomRange(1, hellcount())
		until not (horn_preferexpansions.value and baseexpanded and hellref(hm.horn).base)
	end
end

local function selectHellHorn(hm)
	repeat
		hm.horn = #horns + P_RandomRange(1, #hellhorns)
	until not (horn_preferexpansions.value and hellexpanded and hellref(hm.horn).base)
end

local function selectRandomHorn(hm)
	repeat
		hm.horn = P_RandomRange(1, #horns + #hellhorns)
	until not (horn_preferexpansions.value and baseexpanded and hellref(hm.horn).base)
end

local function initPlayer(hm)
	hm.exploded = false
	hm.postracetimer = 0
	hm.horninput = 0
	hm.hornduration = 0
	hm.hornplaying = false
	hm.sincelasthorn = 0
	hm.horncount = 0
	hm.shake = 0
	hm.flash = 0
	hm.warnstate = 0
end

local function removeOrigin(hm)
	if hm.origin then
		dprint("Removing origin")
		if hm.origin.valid then P_RemoveMobj(hm.origin) end
		hm.origin = nil
	end
	if hm.visual then
		dprint("Removing visual")
		if hm.visual.valid then P_RemoveMobj(hm.visual) end
		hm.visual = nil
		hm.hornplaying = false
	end
end

-- has to go aaaalllllll the way down here...
local horn_enabled = CV_RegisterVar({
	name = "horn_enabled",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function(cv)
		if not cv.value then
			for p in players.iterate do
				if p.hornmod then removeOrigin(p.hornmod) end
			end
		end
	end
})

-- runs before MapLoad
addHook("PlayerSpawn", function(p)
	-- new joiner?
	if not p.hornmod then
		p.hornmod = {}
		initPlayer(p.hornmod)
		p.nethornenabled = not p.hornmod.muted
		-- gotta find consoleplayer because SPLITSCREEEEEEEEN
		if p.splitscreenindex > 0 then
			dprint(p.name, "is looking for their consoleplayer...")
			for px in players.iterate do
				if px.jointime == p.jointime and px.splitscreenindex == 0 then
					dprint("Found", px.name)
					p.hornmod.splitscreenmaster = px
					break
				end
			end
		end
	end
	removeOrigin(p.hornmod)
end)

local playhellsound

-- reset everyone at race start
addHook("MapLoad", function()
	playhellsound = true -- for splitscreen
	for p in players.iterate do
		initPlayer(p.hornmod)
		selectHorn(p.hornmod)
		p.nethornenabled = not p.hornmod.muted
	end
end)

-- silence anyone who leaves
addHook("PlayerQuit", function(p)
	if p.hornmod then removeOrigin(p.hornmod) end
	muffled[#p] = false
end)

-- yes, *pre* thinkframe so we don't have to copy lots of kartstuff variables
addHook("PreThinkFrame", function()
	if leveltime == 0 or #horns == 0 or horn_enabled.value ~= 1 then return end -- leveltime 0 is cursed and runs 3 times.

	for p in players.iterate do
		local hm = p.hornmod
		local mo = p.mo

		if hm.selection and (leveltime == 2) and not (horn_forcehorn.value or horn_truerandom.value) then
			hm.horn = hm.selection
		end

		if not mo or p.playerstate == PST_DEAD then
			removeOrigin(hm)
			continue
		end -- active players only below this line

		-- can't do it in PlayerSpawn because RNG is unsafe there during replays
		if not hm.horn then
			selectHorn(p.hornmod)
		end

		-- can't spawn mobjs in the PlayerSpawn hook either, or else replays crash the game
		if not hm.origin then
			dprint("Spawning origin for", p.name)
			hm.origin = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
			hm.origin.state = S_INVISIBLE
			hm.origin.tics = -1
			hm.origin.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
		end
		
		-- introtime is generally empty on freeplay, so account for that
		local hornintrotime = 2
		if introtime > 0 then
			hornintrotime = introtime - 1*TICRATE
		end

		-- assign hellhorns in the middle of prerace for that extra feeling of slight panic
		-- doesn't nicely format a message for multiple displayplayers getting hellhorns,
		-- but this is already WAAAAY overkill
		if leveltime == hornintrotime
		and not (horn_unleashhell.value or horn_truerandom.value)
		and ((P_RandomRange(1, 1000) <= horn_hellchance.value)) then
			if not globalmute then
				local name = "your"
				for dp in displayplayers.iterate do
					if dp == p then -- that's me!
						if splitscreen > 0 then
							name = dp.name.."'s"
						end
						if playhellsound then -- print once for map hell
							chatprintf(consoleplayer, "\x83*A shadow passes over "..name.." item button...")
							S_StartSound(nil, sfx_hmhell, consoleplayer)
							playhellsound = false
						end
					end
				end
			end
			selectHellHorn(hm)
		end

		-- remind players that hornmod exists and how to work it, i guess
		if p.exiting or (p.lives == 0) then
			hm.postracetimer = $ + 1
			if hm.postracetimer == 2*TICRATE then
				if not (globalmute or hm.selection or hm.faves) then
					CONS_Printf(p, "Your horn that race: "..prettyhornname(hm.horn))
				end
			end
		end

		local hornsound = _G[hellref(hm.horn).name] -- resolve the horn sound for use later down the line
		local maxvolume = hornVolume()
		local hornvolume = maxvolume
		local shutup = hellref(hm.horn).muffled or muffled[#p]

		-- race over?
		if p.exiting then
			hm.horncount = 0 -- don't blow em up
			if p.position ~= 1 then hornvolume = 2*maxvolume/5 end
		end

		-- shutup
		if shutup then
			if horn_shutupbehavior.value == 0 then -- Muffle
				hornvolume = 4*maxvolume/25
			else
				-- Mute
				hornvolume = 0
			end
		end
		-- HORN THINKER --

		P_MoveOrigin(hm.origin, mo.x, mo.y, mo.z) -- moveorigin the origin

		-- draw only if the sound is actually playing, meaning no visuals while muted
		-- (this also affects players with -noaudio)
		hm.shake = max(0, $ - ($/8))
		hm.flash = max($ - 1, 0)
		if hm.hornplaying then
			--print(hm.horn)
			if S_SoundPlaying(hm.origin, hornsound) then
				hm.hornduration = $ + 1

				if not hm.visual then
					dprint("Spawning visual for", p.name)
					local hofs = mo.height - mapobjectscale*8
					if mo.eflags & MFE_VERTICALFLIP then
						hofs = mapobjectscale*8
					end
					hm.visual = P_SpawnMobj(mo.x, mo.y, mo.z + hofs, MT_HORNCODE)
					hm.visual.colorized = true
					hm.visual.target = mo
					-- let's allow shutup'd players to still communicate, but in a less annoying way
					if muffled[#p] then hm.visual.flags2 = $ | MF2_SHADOW end
				end

				-- hellhorns just get angrier as they continue playing
				if hm.horn > #horns and not horn_unleashhell.value then
					hm.shake = max($, hm.hornduration*FRACUNIT/2)
				end

				-- do movement in MobjThinker, otherwise it doesn't account for player movement after PreThinkFrame!
			else
				if hm.visual then
					dprint("Removing visual for", p.name)
					P_RemoveMobj(hm.visual)
					hm.visual = nil
				end
				hm.hornplaying = false
				hm.hornduration = 0
			end
		end

		if horn_antispam.value then
			-- have you been too loud? then it's time to die
			-- we gate this behind no spinout and grounded—no using it to cheese
			-- could check against spbposition as well, but handling that case is kinda wacky...
			-- ...and if you can time a horn explosion to avoid the SPB, IMO you've kinda earned it
			if hm.warnstate == 3
			and P_IsObjectOnGround(mo)
			and p.spinouttimer == 0 then
				-- spawn comical explosion effect
				local explosion = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_GHOST)
				explosion.state = S_HORNEXPLOSION
				explosion.scale = p.mo.scale*4
				explosion.dispoffset = 999
				S_StartSound(p.mo, sfx_hmbebo)
				-- trying to explode for attention? no thanks.
				if hm.exploded then
					S_StartSound(p.mo, sfx_kc3b)
					-- your loss.
					P_DamageMobj(p.mo, p.mo, nil, 999, DMG_TUMBLE)
					p.mo.hitlag = 3
					p.mo.momz = $ + (72*mapobjectscale * P_MobjFlip(p.mo))
					-- bouncer
					p.tumblebounces = 1
				else
					-- but yeah fucking die lmao
					P_KillMobj(p.mo, nil, nil)
				end
				hm.exploded = true
				hm.horncount = 0
				hm.warnstate = 0
				continue -- don't need to play any horns
			end

			-- reset if they haven't touched the horn for a few seconds.
			if hm.warnstate > 0 and hm.warnstate < 3 and hm.sincelasthorn > 5*TICRATE then
				hm.horncount = 0
				hm.warnstate = 0
			end
			hm.sincelasthorn = $ + 1
		end

		-- are we pressing horn? and are we able to horn?
		hm.horninput = p.cmd.buttons & BT_VOTE and $ + 1 or 0
		
		-- look, we want bots to horn
		if p.bot or p.exiting then
			-- they will only attempt to horn at 10 tick intervals....
			if leveltime % 10 == 0 then
				-- ....roll a 25-side die and attempt to horn or not.
				-- this totally wont get annoying
				if P_RandomRange(0, 24) == 0 then hm.horninput = $ + 1 end
			end
		end
	
		if hm.horninput == 1 then
			if horn_truerandom.value then
				selectRandomHorn(hm)
				hornsound = _G[hellref(hm.horn).name]
			elseif horn_forcehorn.value then
				hm.horn = horn_forcehorn.value
				hornsound = _G[hellref(hm.horn).name]
			end

			-- should we be doing spam calculations? if you're under a powerup or in 1v1, you're immune.
			if horn_antispam.value
			and leveltime > starttime
			and playercount() > 2
			and not (p.growshrinktimer > 0 or p.invincibilitytimer or hm.muted) then
				-- a small amount of uncertainty makes the spam warning more forboding
				hm.horncount = $ + 1 + (leveltime & 1)
				-- spamming horns slowly means more total time spent playing noises
				-- this is basically a discount on rapid mashing, since it's not actually that disruptive
				if hm.sincelasthorn >= TICRATE/2 then
					hm.horncount = $ + 2
				end
				hm.sincelasthorn = 0

				-- warnstate tracks what level of warning the player knows they're under
				-- at warnstate 3, you die!

				-- cues for various levels of warnstate
				if hm.horncount > 39 and hm.warnstate == 2 then
					hm.warnstate = 3
				elseif hm.horncount > 26 and hm.warnstate == 1 then
					hm.warnstate = 2
					S_StartSoundAtVolume(nil, sfx_hmdang, 255, p)
					S_StartSoundAtVolume(nil, sfx_s3k50, 160, p)
				elseif hm.horncount > 13 and (not hm.warnstate) then
					hm.warnstate = 1
					S_StartSoundAtVolume(nil, sfx_hmwarn, 255, p)
					S_StartSoundAtVolume(nil, sfx_s3kb2, 160, p)
				end
			end

			-- don't play if muted
			-- do it here or else replays desync
			if (hm.muted and not replayplayback) or globalmute then continue end

			local displayplayer
			for dp in displayplayers.iterate do
				if dp == p then displayplayer = p end
			end

			-- step 2: play the rest of the fucking horn
			if leveltime > introtime
			or p == displayplayer then
				hm.flash = 2 -- yellow flash for a little extra impact
				hm.shake = $ + 10*FRACUNIT -- and a little bit of extra sauce for the visual
				hm.hornplaying = true
				S_StopSound(hm.origin)
				if p == displayplayer and not shutup then
					S_StartSoundAtVolume(hm.origin, hornsound, maxvolume) -- sneaky...always hear your own horns at max volume
				else
					S_StartSoundAtVolume(hm.origin, hornsound, hornvolume)
				end
			end
		end
	end
end)

hud.add(function(v, p)
	local hm = p.hornmod or {warnstate = 0}
	if hm.warnstate then
		local warnings = {"\130EASE OFF THE HORN", "\133I ASKED POLITELY", "\133TIME TO DIE"}

		-- VERY quick and dirty splitscreen

		local splitindex
		for dp, i in displayplayers.iterate do
			if dp == p then splitindex = i end
		end

		local x, y = 160, 30

		if splitscreen == 1 then
			if splitindex & 1 then
				y = 120 -- 1P
			else
				y = 20 -- 2P
			end
		elseif splitscreen > 1 then
			if splitindex & 1 then
				x = 240 -- 2P/4P
			else
				x = 80 -- 1P/3P
			end
			if splitindex & 2 then
				y = 120 -- 3P/4P
			else
				y = 20 -- 1P/2P
			end
		end

		v.drawString(x, y, warnings[hm.warnstate], (min(hm.sincelasthorn, 9) & 1) and V_50TRANS, "center")
	end
end)

-- API stuff

rawset(_G, "HORNMOD_AddHorns", function(...) -- expects same format as the horn table up top
	local packedargs = {...}
	for k, v in ipairs(packedargs) do
		allocatenewhorn(v.name)
		table.insert(horns, v)
		print("HORNMOD: Added " .. v.name)
		-- oh yeah, let's make sure the script knows preferexpansions will work
		if not v.base then baseexpanded = true end
	end
end)

rawset(_G, "HORNMOD_AddHellHorns", function(...)
	local packedargs = {...}
	for k, v in ipairs(packedargs) do
		v.hell = true
		allocatenewhorn(v.name)
		table.insert(hellhorns, v)
		print("HORNMOD: Added " .. v.name)
		if not v.base then hellexpanded = true end
	end
end)
